## libdigidocpp 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(libdigidocpp)

# Custom cmake modules
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

include(InstallSettings)

if(WIN32)
    set(PKCS11_MODULE "opensc-pkcs11.dll")
elseif(APPLE)
    set(PKCS11_MODULE "/Library/OpenSC/lib/opensc-pkcs11.so")
else()
    set(PKCS11_MODULE "opensc-pkcs11.so")
endif()

if(LIBDIGIDOC_MODULE)
    add_definitions(-DLIBDIGIDOC_NAME="${LIBDIGIDOC_MODULE}")
endif(LIBDIGIDOC_MODULE)

set(DIGIDOCPP_INCLUDE_DIR "${INCLUDE_INSTALL_DIR}/digidocpp")
set(DIGIDOCPP_CONFIG_DIR  "${SYSCONF_INSTALL_DIR}/digidocpp")
add_definitions(-DDIGIDOCPP_CONFIG_DIR="${DIGIDOCPP_CONFIG_DIR}")
set(DIGIDOCPP_VERSION     "0.3.0")

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/libdigidocpp.pc.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/libdigidocpp.pc
    @ONLY
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libdigidocpp.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)

if(UNIX AND NOT APPLE)
    find_package(Iconv REQUIRED)
endif(UNIX AND NOT APPLE)
find_package(LibDigiDoc REQUIRED)
if(UNIX)
    find_package(LibDL)
endif(UNIX)
find_package(LibP11 REQUIRED)
find_package(OpenSSL REQUIRED)
find_package(OpenSSLCrypto REQUIRED)
#find_package(PKCS11H REQUIRED)
find_package(XercesC REQUIRED)
find_package(XmlSecurityC REQUIRED)
find_package(XSD REQUIRED)

find_package(MiniZip QUIET)
if(MINIZIP_FOUND)
    message(STATUS "Found MiniZip: ${MINIZIP_LIBRARIES}")
else()
    message(STATUS "MiniZip not found; using bundled copy.")
    set(MINIZIP_INCLUDE_DIR ${CMAKE_SOURCE_DIR}/src/minizip)
    # zlib is only required for building minizip
    find_package(ZLIB REQUIRED)
endif()

option(ENABLE_BINDINGS "Build bindings." TRUE)
if(ENABLE_BINDINGS)
    ## Packages required for Dynamic Language Wrappers
    find_package(SWIG)
    if(SWIG_FOUND)
        find_package(PythonLibs)
        find_package(PerlLibs)
        find_package(PHPLibs)
    endif(SWIG_FOUND)
endif()

add_subdirectory(etc)
add_subdirectory(src)

option(BUILD_TESTS "Build tests." FALSE)
if (BUILD_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()

=== etc/CMakeLists.txt ===
configure_file(digidocpp.conf.cmake ${CMAKE_CURRENT_BINARY_DIR}/digidocpp.conf)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/digidocpp.conf
    DESTINATION ${DIGIDOCPP_CONFIG_DIR}
)

install(DIRECTORY
    certs
    DESTINATION ${DIGIDOCPP_CONFIG_DIR}
    REGEX "\\.svn$|_svn$" EXCLUDE
)

add_subdirectory(schema)

=== src/CMakeLists.txt ===
include_directories(
    ${ICONV_INCLUDE_DIR}
    ${LIBDIGIDOC_INCLUDE_DIR}
    ${LIBDL_INCLUDE_DIR}
    ${LIBP11_INCLUDE_DIR}
    ${PKCS11H_INCLUDE_DIR}
    ${MINIZIP_INCLUDE_DIR}
    ${OPENSSL_INCLUDE_DIR}
    ${OPENSSLCRYPTO_INCLUDE_DIR}
    ${XERCESC_INCLUDE_DIR}
    ${XMLSECURITYC_INCLUDE_DIR}
    ${XSD_INCLUDE_DIR}
    ${ZLIB_INCLUDE_DIR}
)

set(SCHEMA_DIR ${CMAKE_SOURCE_DIR}/etc/schema)
set(XML_DIR ${CMAKE_CURRENT_BINARY_DIR}/xml)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(COMMON_XSD_OPTS
    --type-naming ucc
    --function-naming lcc
    --generate-doxygen
    --generate-intellisense
    --root-element-first
    --output-dir ${XML_DIR}
)

# generate manifest xml parser files
add_custom_command(
    OUTPUT ${XML_DIR}/OpenDocument_manifest.cxx
    COMMAND ${CMAKE_COMMAND} -E make_directory ${XML_DIR}
    COMMAND ${XSD_EXECUTABLE} cxx-tree ${COMMON_XSD_OPTS}
                                       --generate-serialization
                                       --namespace-map urn:oasis:names:tc:opendocument:xmlns:manifest:1.0=digidoc::manifest
                                       OpenDocument_manifest.xsd
    WORKING_DIRECTORY ${SCHEMA_DIR}
    DEPENDS ${SCHEMA_DIR}/OpenDocument_manifest.xsd
)

# generate XML DSig xml parser files
add_custom_command(
    OUTPUT ${XML_DIR}/xmldsig-core-schema.cxx
    COMMAND ${CMAKE_COMMAND} -E make_directory ${XML_DIR}
    COMMAND ${XSD_EXECUTABLE} cxx-tree ${COMMON_XSD_OPTS}
                                       --generate-serialization
                                       --namespace-map http://www.w3.org/2000/09/xmldsig\#=digidoc::dsig
                                       --namespace-map http://uri.etsi.org/01903/v1.3.2\#=digidoc::xades
                                       xmldsig-core-schema.xsd
    WORKING_DIRECTORY ${SCHEMA_DIR}
    DEPENDS ${SCHEMA_DIR}/xmldsig-core-schema.xsd
)

# generate XAdES xml parser files
add_custom_command(
    OUTPUT ${XML_DIR}/XAdES.cxx
    COMMAND ${CMAKE_COMMAND} -E make_directory ${XML_DIR}
    COMMAND ${XSD_EXECUTABLE} cxx-tree ${COMMON_XSD_OPTS}
                                       --generate-serialization
                                       --namespace-map http://www.w3.org/2000/09/xmldsig\#=digidoc::dsig
                                       --namespace-map http://uri.etsi.org/01903/v1.3.2\#=digidoc::xades
                                       XAdES.xsd
    WORKING_DIRECTORY ${SCHEMA_DIR}
    DEPENDS ${SCHEMA_DIR}/XAdES.xsd
)

add_custom_command(
    OUTPUT ${XML_DIR}/conf.cxx
    COMMAND ${CMAKE_COMMAND} -E make_directory ${XML_DIR}
    COMMAND ${XSD_EXECUTABLE} cxx-tree ${COMMON_XSD_OPTS}
                                       --generate-serialization
                                       conf.xsd
    WORKING_DIRECTORY ${SCHEMA_DIR}
    DEPENDS ${SCHEMA_DIR}/conf.xsd
)


if(NOT MINIZIP_FOUND)
    # Use bundled copy of minizip if not found in system
    set(minizip_SRCS
        minizip/zip.c
        minizip/unzip.c
        minizip/ioapi.c
    )

    if(WIN32)
        set(minizip_SRCS
            ${minizip_SRCS}
            minizip/iowin32.c
        )
    endif(WIN32)
endif(NOT MINIZIP_FOUND)

set(digidocpp_SRCS
    ADoc.cpp
    BDoc.cpp
    BDocException.cpp
    DDoc.cpp
    log.cpp
    Conf.cpp
    XmlConf.cpp
    Document.cpp
    Exception.cpp
    Signature.cpp
    SignatureBES.cpp
    SignatureTM.cpp
    SignatureMobile.cpp
    SignatureException.cpp
    SignatureAttributes.cpp
    WDoc.cpp
    crypto/Digest.cpp
    crypto/cert/X509Cert.cpp
    crypto/cert/X509CertStore.cpp
    crypto/cert/DirectoryX509CertStore.cpp
    crypto/ocsp/OCSP.cpp
    crypto/ocsp/OCSPException.cpp
    crypto/crypt/RSACrypt.cpp
    crypto/signer/PKCS11Signer.cpp
    crypto/signer/EstEIDSigner.cpp
    crypto/signer/RSASigner.cpp
    crypto/signer/Signer.cpp
    crypto/signer/SignException.cpp
    io/IOException.cpp
    io/ISerialize.cpp
    io/ZipSerialize.cpp
    util/String.cpp
    util/File.cpp
    util/DateTime.cpp
    ${XML_DIR}/conf.cxx
    ${XML_DIR}/OpenDocument_manifest.cxx
    ${XML_DIR}/xmldsig-core-schema.cxx
    ${XML_DIR}/XAdES.cxx
)

if(ICONV_SECOND_ARGUMENT_IS_CONST)
    add_definitions( -DICONV_SECOND_ARGUMENT_IS_CONST )
endif(ICONV_SECOND_ARGUMENT_IS_CONST)

if(CMAKE_COMPILER_IS_GNUCC)
    add_definitions( -Wno-format )
endif(CMAKE_COMPILER_IS_GNUCC)

if(WIN32)
    add_definitions( -DWIN32_LEAN_AND_MEAN )
endif(WIN32)

if(MSVC)
    # disable warning C4290: C++ exception specification ignored
    add_definitions( -wd4290 )
    add_definitions(
        -D_CRT_SECURE_NO_DEPRECATE
        -D_CRT_SECURE_NO_WARNINGS
        -D_SCL_SECURE_NO_WARNINGS
    )
endif(MSVC)

# xCode and static linking hacks
if(APPLE)
	include_directories(/Library/OpenSC/include)
	include_directories(/usr/local/include/../include)
	find_library(CARBON_LIBRARY Carbon)
	find_library(COREFOUNDATION_LIBRARY CoreFoundation)
	mark_as_advanced(CARBON_LIBRARY COREFOUNDATION_LIBRARY)
	set(EXTRA_LIBS ${CARBON_LIBRARY} ${COREFOUNDATION_LIBRARY})
endif(APPLE)

add_library(digidocpp SHARED ${digidocpp_SRCS} ${minizip_SRCS})
target_link_libraries(digidocpp
    ${ICONV_LIBRARIES}
    ${LIBP11_LIBRARIES}
    ${PKCS11H_LIBRARIES}
    ${LIBDL_LIBRARIES}
    ${MINIZIP_LIBRARIES}
    ${OPENSSLCRYPTO_LIBRARIES}
    ${OPENSSL_LIBRARIES}
    ${XERCESC_LIBRARIES}
    ${XMLSECURITYC_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${EXTRA_LIBS}
)
if(UNIX)
    set(VISIBILITY_FLAG "-fvisibility=hidden")
endif(UNIX)

set_target_properties(digidocpp
    PROPERTIES
    VERSION ${DIGIDOCPP_VERSION}
    SOVERSION 0
    COMPILE_FLAGS "${VISIBILITY_FLAG}"
    )
install(TARGETS digidocpp DESTINATION ${INSTALL_TARGETS_DEFAULT_ARGS})

add_executable(digidoc-demo main_demo.cpp)
target_link_libraries(digidoc-demo digidocpp)

add_executable(digidoc-tool bdoc_ref.cpp)
target_link_libraries(digidoc-tool digidocpp)

install( FILES
    ADoc.h
    BDocException.h
    BDoc.h
    Conf.h
    DDoc.h
    Document.h
    Exception.h
    Exports.h
    Signature.h
    SignatureAttributes.h
    SignatureBES.h
    SignatureException.h
    SignatureMobile.h
    SignatureTM.h
    WDoc.h
    XmlConf.h
    DESTINATION ${DIGIDOCPP_INCLUDE_DIR}
)

install( FILES
    crypto/Digest.h
    crypto/OpenSSLHelpers.h
    DESTINATION ${DIGIDOCPP_INCLUDE_DIR}/crypto
)

install( FILES
    crypto/cert/DirectoryX509CertStore.h
    crypto/cert/X509Cert.h
    crypto/cert/X509CertStore.h
    DESTINATION ${DIGIDOCPP_INCLUDE_DIR}/crypto/cert
)

install( FILES
    crypto/crypt/RSACrypt.h
    DESTINATION ${DIGIDOCPP_INCLUDE_DIR}/crypto/crypt
)

install( FILES
    crypto/ocsp/OCSPException.h
    crypto/ocsp/OCSP.h
    DESTINATION ${DIGIDOCPP_INCLUDE_DIR}/crypto/ocsp
)

install( FILES
    crypto/signer/EstEIDSigner.h
    crypto/signer/PKCS11Signer.h
    crypto/signer/RSASigner.h
    crypto/signer/Signer.h
    crypto/signer/SignException.h
    DESTINATION ${DIGIDOCPP_INCLUDE_DIR}/crypto/signer
)

install( FILES
    io/IOException.h
    io/ISerialize.h
    io/ZipSerialize.h
    DESTINATION ${DIGIDOCPP_INCLUDE_DIR}/io
)

install( FILES
    util/String.h
    DESTINATION ${DIGIDOCPP_INCLUDE_DIR}/util
)

install( FILES
    ${XML_DIR}/XAdES.hxx
    ${XML_DIR}/xmldsig-core-schema.hxx
    ${XML_DIR}/conf.hxx
    DESTINATION ${DIGIDOCPP_INCLUDE_DIR}/xml
)

## Generate Dynamic Language Wrappers
macro(DO_SWIG_MODULE language)
  string(TOUPPER "${language}" lang_ucase)
  message(STATUS "Building ${language} bindings")

  # Ugly hack to make target names differ so CMake will be happy
  set (module_name ${SWIG_MODULE_NAME}__${lang_ucase}__)
  set(MODULE_INCLUDE_DIRS
      ${${lang_ucase}_INCLUDE_DIRS}
      ${CMAKE_CURRENT_BINARY_DIR}/${language}
      ${CMAKE_CURRENT_SOURCE_DIR})
  # Another ugly hack to add includes only to module
  # sources not the entire build. We can't just use include_directories :(
  foreach(it ${MODULE_INCLUDE_DIRS})
      set(module_include_flags "${module_include_flags} -I${it}")
  endforeach(it)
  set_source_files_properties(${SWIG_FILES} PROPERTIES CPLUSPLUS ON)
  set(mod_outdir "${CMAKE_CURRENT_BINARY_DIR}/${language}")
  set(CMAKE_SWIG_OUTDIR "${mod_outdir}")
  SWIG_ADD_MODULE(${module_name} ${language} ${SWIG_FILES})
  SWIG_LINK_LIBRARIES(${module_name} ${${lang_ucase}_LIBRARIES} digidocpp)
  string(REPLACE "__${lang_ucase}__" "" mod_outname
         "${SWIG_MODULE_${module_name}_REAL_NAME}")
  set_target_properties(${SWIG_MODULE_${module_name}_REAL_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${mod_outdir}"
    COMPILE_FLAGS "${module_include_flags}"
    PREFIX ""
    OUTPUT_NAME "${mod_outname}")
  set(${lang_ucase}_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/${language}/${SWIG_MODULE_NAME}.${SWIG_${lang_ucase}_EXTRA_FILE_EXTENSION})
  list(APPEND wrappers_DEPS ${SWIG_MODULE_${module_name}_REAL_NAME})
  list(APPEND wrappers_SRCS ${${lang_ucase}_WRAPPER})
  install(TARGETS ${SWIG_MODULE_${module_name}_REAL_NAME} 
    LIBRARY DESTINATION "${${lang_ucase}_EXTENSION_DIR}")
endmacro(DO_SWIG_MODULE language)

if(SWIG_FOUND)
  include(${SWIG_USE_FILE})
  # TODO: Send this fix to upstream
  SET(SWIG_PERL_EXTRA_FILE_EXTENSION "pm")
  SET(SWIG_PHP_EXTRA_FILE_EXTENSION "php")

  set (SWIG_FILES        digidoc.i)
  set (SWIG_MODULE_NAME  "digidoc")

  # Python
  if(PYTHONLIBS_FOUND)
    # Pull in KDE crap for PYTHON_SITE_PACKAGES_DIR and PYTHON_INSTALL
    find_package(PythonLibrary QUIET)
    include(PythonMacros)
    set(PYTHON_EXTENSION_DIR "${PYTHON_SITE_PACKAGES_DIR}")

    # CMake 2.6
    if(NOT DEFINED PYTHON_INCLUDE_DIRS)
      set(PYTHON_INCLUDE_DIRS "${PYTHON_INCLUDE_PATH}")
    endif(NOT DEFINED PYTHON_INCLUDE_DIRS)

    DO_SWIG_MODULE(python)
    PYTHON_INSTALL(${PYTHON_WRAPPER} ${PYTHON_EXTENSION_DIR})
    # This is a braindead hack! PYTHON_INSTALL is just broken
    add_dependencies(compile_python_files swig-wrappers)
  endif(PYTHONLIBS_FOUND)

  # Perl
  if(PERLLIBS_FOUND)
    set(PERL_EXTENSION_DIR "${PERL_VENDORARCH}/auto")
    DO_SWIG_MODULE(perl)
    install(FILES ${PERL_WRAPPER} DESTINATION "${PERL_VENDORLIB}")
  endif(PERLLIBS_FOUND)

  # PHP
  if(PHPLIBS_FOUND)
    if(NOT PHP_WRAPPER_DIR)
      set(PHP_WRAPPER_DIR "${PHP_INSTALL_PREFIX}/share/php")
    endif(NOT PHP_WRAPPER_DIR)
    DO_SWIG_MODULE(php)
    set(PHP_INIFILE ${CMAKE_CURRENT_BINARY_DIR}/php/${SWIG_MODULE_NAME}.ini)
    file(WRITE ${PHP_INIFILE} "extension=${SWIG_MODULE_NAME}.so\n")
    install(FILES ${PHP_WRAPPER} DESTINATION "${PHP_WRAPPER_DIR}")
    install(FILES ${PHP_INIFILE} DESTINATION "${SYSCONF_INSTALL_DIR}/php.d")
  endif(PHPLIBS_FOUND)

  add_custom_target(swig-wrappers ALL
    DEPENDS ${wrappers_DEPS}
    SOURCES ${wrapper_SRCS})

endif(SWIG_FOUND)

=== test/CMakeLists.txt ===
find_package(CppUnit REQUIRED)

include_directories(
    ${MINIZIP_INCLUDE_DIR}
    ${OPENSSL_INCLUDE_DIR}
)

set(unittests_SRCS
    src/crypto/DigestTest.cpp
    src/io/ZipSerializeTest.cpp
    src/main_unittest.cpp
    src/SignatureBESTest.cpp
)

if(WIN32)
    add_definitions(
      -DNDEBUG
      -DWIN32
      -DXSEC_NO_XALAN
      -D_CONSOLE
      -D_CRT_SECURE_NO_DEPRECATE
      -D_CRT_SECURE_NO_WARNINGS
    )

    target_link_libraries( unittests libeay32 ssleay32 zlib xerces-c_2D xsec_1D TestRunnerd cppunitd )
endif(WIN32)

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}/../src
    ${CMAKE_CURRENT_SOURCE_DIR}/../src
)

add_executable( unittests WIN32 ${unittests_SRCS} )
target_link_libraries( unittests cppunit digidocpp ${OPENSSL_LIBRARIES} )

add_custom_target( test-stage
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/data ${CMAKE_CURRENT_BINARY_DIR}/data
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/test.py ${CMAKE_CURRENT_BINARY_DIR}
)
add_dependencies( unittests test-stage )

add_test(PythonTest test.py)

=== etc/schema/CMakeLists.txt ===
set( SCHEMA_FILES
    conf.xsd
    datatypes.dtd
    OpenDocument_manifest.xsd
    XAdES.xsd
    xmldsig-core-schema.xsd
    XMLSchema.dtd
)
install(FILES ${SCHEMA_FILES} DESTINATION ${DIGIDOCPP_CONFIG_DIR}/schema)

=== debian/changelog ===
libdigidocpp (0.3.0-0ubuntu11) xenial; urgency=medium

  * PHP bindings are not packaged, so there is no build-dependency (LP:
    #1566394).

 -- Nishanth Aravamudan <nish.aravamudan@canonical.com>  Tue, 05 Apr 2016 08:30:27 -0700

libdigidocpp (0.3.0-0ubuntu10) xenial; urgency=medium

  * Drop python-support build-depends, python bindings are not built.
  * Comment out comparison with CONTENT_HASHCODE, which is not defined
    anywhere at all...

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 23 Feb 2016 14:03:47 +0000

libdigidocpp (0.3.0-0ubuntu9) wily; urgency=medium

  * No-change rebuild against libxml-security-c17v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 10 Aug 2015 23:34:28 +0000

libdigidocpp (0.3.0-0ubuntu8) vivid; urgency=medium

  * Replace NBS zlib-bin build dep with minizip.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 02 Feb 2015 15:19:35 +0100

libdigidocpp (0.3.0-0ubuntu7) saucy; urgency=low

  * Rebuild for libxml-security-c17.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 16 Jul 2013 18:14:46 +0100

libdigidocpp (0.3.0-0ubuntu6) quantal; urgency=low

  * 0002_missing_include.patch:
    + Added new patch from upstream SVN to add missing G++ 4.7 include.

 -- Martin-Éric Racine <q-funk@ubuntu.com>  Mon, 30 Apr 2012 17:36:14 +0300

libdigidocpp (0.3.0-0ubuntu5) quantal; urgency=low

  * Build-Depends: added zlib-bin for MiniZip.
  * Bumped Standards-Version to 3.9.3 (no change required).

 -- Martin-Éric Racine <q-funk@ubuntu.com>  Fri, 27 Apr 2012 12:26:36 +0300

libdigidocpp (0.3.0-0ubuntu4) precise; urgency=low

  * 0001_new_EstEID_root_CA.patch:
    + Add the latest EstEID root CA issued by Sertifitseerimiskeskus.

 -- Martin-Éric Racine <q-funk@ubuntu.com>  Wed, 07 Mar 2012 03:08:59 +0200

libdigidocpp (0.3.0-0ubuntu3) precise; urgency=high

  * Urgency=high; this library is stalling 3 other packages in dep-wait.
  * Reintroduce CDBS list-missing only for common-binary-post-install-arch.

 -- Martin-Éric Racine <q-funk@ubuntu.com>  Fri, 27 Jan 2012 17:48:56 +0200

libdigidocpp (0.3.0-0ubuntu2) precise; urgency=low

  * Replace CDBS utils.mk list-missing with dh_install --list-missing.
    - Removed: include /usr/share/cdbs/1/rules/utils.mk,
      common-binary-post-install-arch common-binary-post-install-indep::
    + Added: DEB_DH_INSTALL_ARGS += --list-missing

 -- Martin-Éric Racine <q-funk@ubuntu.com>  Thu, 26 Jan 2012 22:12:19 +0200

libdigidocpp (0.3.0-0ubuntu1) precise; urgency=low

  * Initial release for Ubuntu (LP: #916434).
    Based upon initial packaging by Kalev Lember, with further improvements
    by Guido Tabbernuk, then packaging review by Martin-Éric Racine.
  * Perl/PHP/Python bindings are not packaged for this version. Upstream
    doesn't consider them as ready for public consumption just yet.

 -- Martin-Éric Racine <q-funk@ubuntu.com>  Sat, 14 Jan 2012 02:47:58 +0200

=== debian/control ===
Source: libdigidocpp
Section: libs
Priority: optional
Homepage: http://code.google.com/p/esteid/
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Guido Tabbernuk <boamaod@gmail.com>, Martin-Éric Racine <martin-eric.racine@iki.fi>
Build-Depends: cdbs, debhelper (>= 7), cmake, pkg-config, 
 libdigidoc-dev, libp11-dev, libperl-dev, libpkcs11-helper-dev, 
 libssl-dev, libxml-security-c-dev,
 swig, xsdcxx, minizip
Standards-Version: 3.9.3

Package: libdigidocpp-common
Architecture: all
Section: misc
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: libdigidocpp architecture-independent files
 BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
 Older Digidoc formats (DIGIDOC-XML) are not supported.
 .
 This package provides the architecture-independent files.

Package: libdigidocpp-dev
Section: libdevel
Architecture: any
Breaks: libdigidoc0-dev (<< 0.1.0), libdigidoc++0-dev (<< 0.1.0)
Replaces: libdigidoc0-dev (<< 0.1.0), libdigidoc++0-dev (<< 0.1.0)
Depends: libdigidocpp0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
 libdigidoc-dev, libp11-dev, libssl-dev, libxml-security-c-dev, xsdcxx 
Description: libdigidocpp development files
 BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
 Older Digidoc formats (DIGIDOC-XML) are not supported.
 .
 This package provides the development files.

#Package: perl-digidoc
#Section: perl
#Architecture: any
#Depends: libdigidocpp0 (= ${binary:Version}), ${perl:Depends}, ${misc:Depends}, ${shlibs:Depends}
#Description: libdigidocpp Perl bindings
# BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
# Older Digidoc formats (DIGIDOC-XML) are not supported.
# .
# This package provides the Perl bindings.

#Package: php-digidoc
#Section: php
#Architecture: any
#Depends: libdigidocpp0 (= ${binary:Version}), ${php:Depends}, ${misc:Depends}, ${shlibs:Depends}
#Description: libdigidocpp PHP bindings
# BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
# Older Digidoc formats (DIGIDOC-XML) are not supported.
# .
# This package provides the PHP bindings.

#Package: python-digidoc
#Section: python
#Architecture: any
#Depends: libdigidocpp0 (= ${binary:Version}), ${python:Depends}, ${misc:Depends}, ${shlibs:Depends}
#Description: libdigidocpp Python bindings
# BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
# Older Digidoc formats (DIGIDOC-XML) are not supported.
# .
# This package provides the Python bindings.

Package: libdigidocpp0-dbg
Architecture: any
Section: debug
Priority: extra
Breaks: libdigidoc0-dbg (<< 0.1.0), libdigidoc++0-dbg (<< 0.1.0)
Replaces: libdigidoc0-dbg (<< 0.1.0), libdigidoc++0-dbg (<< 0.1.0)
Depends: libdigidocpp0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: libdigidocpp debugging symbols
 BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
 Older Digidoc formats (DIGIDOC-XML) are not supported.
 .
 This package provides the debugging symbols.
 
Package: libdigidocpp0
Architecture: any
Provides: libdigidoc0, libdigidoc++0
Breaks: libdigidoc0 (<< 0.1.0), libdigidoc++0 (<< 0.1.0)
Replaces: libdigidoc0 (<< 0.1.0), libdigidoc++0 (<< 0.1.0)
Depends: libdigidocpp-common, opensc, ${misc:Depends}, ${shlibs:Depends}
Description: BDoc C++ library for processing digital signatures
 BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
 Older Digidoc formats (DIGIDOC-XML) are not supported. Difference between
 DDoc, EDoc and BDoc are described in. BDoc signatures should be XAdES
 compliant, but some XAdES signatures may be uncompliant with BDoc. Currently
 BDoc-1.0 BES and TM profiles are supported.
 .
 Signatures can be given using EstEID Card (id-kaart) and RSA certificates
 with private keys.
 .
 This package provides the runtime libraries.

=== debian/rules ===
#!/usr/bin/make -f
# [debian/rules] for libdigidocpp
#
# COPYRIGHT
# © 2012 Martin-Éric Racine <martin-eric.racine@iki.fi>
# © 2012 Guido Tabbernuk <boamaod@gmail.com>
#
# LICENSE
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_CMAKE_EXTRA_FLAGS += -DSYSCONF_INSTALL_DIR=/etc

#install/php-digidoc::
#	echo "php:Depends=phpapi-$(shell php-config5 --phpapi)" >> debian/php-digidoc.substvars

#install/python-digidoc::
#	find debian/tmp/ -name "*.pyc" -depth -exec rm -rf {} \;

common-binary-post-install-arch:: list-missing

#EOF

=== debian/watch ===
version=3
http://esteid.googlecode.com/files/libdigidocpp-([\d\.]+)\.tar\.bz2 \
	debian uupdate --no-symlink
